#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/sctp.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <errno.h>

int main(int argc, char **argv)
{
	struct sockaddr_storage addr_cli, addr_ser;
	struct addrinfo *local_info = NULL;
	struct sockaddr_storage peeraddr;
	socklen_t len = sizeof(peeraddr);
	int fd, sockcnt, flag = 1, i;
	int log = 0;

	if (argc != 3) {
		printf("Usage: %s <local_port> <local_port>\n", argv[0]);
		exit(-1);
	}

	memset(&addr_ser, 0, sizeof(addr_ser));
	if (getaddrinfo(argv[1], argv[2], NULL, &local_info) != 0) {
		perror("getaddrinfo");
		exit(-1);
	}
	memcpy(&addr_ser, local_info->ai_addr, local_info->ai_addrlen);

	if ((fd = socket(local_info->ai_family, SOCK_SEQPACKET, IPPROTO_SCTP)) == -1){
		perror("socket");
		exit(-1);
	}

	len = sizeof(flag);
	flag = 1;
	if (-1 == setsockopt(fd, SOL_SOCKET, SO_REUSEPORT, &flag, sizeof(flag))) {
		perror("setsockopt fail");
		exit(-1);
	}

	if (bind(fd, (struct sockaddr *)&addr_ser, sizeof(addr_ser)) == -1){
		perror("bind");
		exit(-1);
	}
	if (-1 == listen(fd, 10)) {
		perror("listen");
		exit(-1);
	}

	while (1) {
		int recv_len, len, msg_flags = 0;
		struct sockaddr_storage addr_cli;
		struct sctp_sndrcvinfo sri;
		char buf[10240];

		len = sizeof(addr_cli);
		memset(&addr_cli, 0, len);

		recv_len = sctp_recvmsg(fd, buf, sizeof(buf),
				(struct sockaddr *)&addr_cli,
				&len, &sri, &msg_flags);
		if (recv_len == -1) {
			perror("recvmsg");
			exit(-1);
		}
		if (log++ == 5) {
			system("cat /proc/net/sctp/eps");
			system("cat /proc/net/sctp/assocs");
		}
		printf("recvmsg %d\n", recv_len);
	}

	return 0;
}
